<?php

//error_reporting(-1);
//
//require_once './simplepie.inc';

class LifeStream extends SimplePie {
    
    private $instance;
    private $urls;
    private $rows;
    private $twitter = array();
    private $favicon = '';
    private $output = '';
    private $i = 1;
    
    function LifeStream($rows = 10) {
        $this->rows = $rows > 200 ? 200 : $rows;
        $this->instance = new SimplePie(NULL,  './cache/', 1800);
    }
    
    function addTwitter($username) {
        $this->twitter[] = $username;
        $this->urls[] = 'http://api.twitter.com/1/statuses/user_timeline/' . $username . '.rss?count=' . $this->rows;
    }
    
    function addDelicious($username) {
        $this->urls[] = 'http://feeds.delicious.com/v2/rss/' . $username . '?count=' . $this->rows;
    }
    
    function addFlickr($username) {
        $this->urls[] = 'http://api.flickr.com/services/feeds/photos_public.gne?id=' . $username . '&format=rss_200';
    }
    
    function addTumblr($username) {
        $this->urls[] = 'http://' . $username . '.tumblr.com/rss';
    }
    
    function addYouTube($username) {
        $this->urls[] = 'http://gdata.youtube.com/feeds/base/users/' . $username . '/uploads';
    }
    
    function addDribbble($username) {
        $this->urls[] = 'http://dribbble.com/players/' . $username . '/shots.rss';
    }
    
    function addDigg($username) {
        $this->urls[] = 'http://digg.com/users/' . $username . '/history.rss';
    }
    
    function addVimeo($username) {
        $this->urls[] = 'http://vimeo.com/' . $username . '/videos/rss';
    }
    
    function addCustomFeed($feedurl,$icon = NULL) {
        $this->urls[] = $feedurl;
        $this->icon[$feedurl] = $icon;
    }
    
    function build() {
        $this->instance->set_feed_url($this->urls);
        $this->instance->init();
        $this->instance->handle_content_type();
        
        if($this->instance->error) {
            $this->output .= $this->instance->error;
        }
        else {
            $this->output .= "<ul class='lifestream'>\n";
            foreach ($this->instance->get_items() as $item) {
                if($this->i > $this->rows) break;
                $feed = $item->get_feed();
                $this->favicon = $feed->get_favicon();
                if(isset($this->icon[$feed->subscribe_url()])) {
                    if($this->icon[$feed->subscribe_url()]!='')
                        $this->favicon = $this->icon[$feed->subscribe_url()];
                }
                $this->output .= "<li style='background-image:url(" . $this->favicon . ");'>\n";
                $itemTitle = $item->get_title();
                foreach($this->twitter as $twitterUsername) {
                    if($feed->get_link() == 'http://twitter.com/' . $twitterUsername) {
                        $itemTitle = substr($item->get_title(),strlen($twitterUsername)+2);
                    }
                }
                $this->output .= $this->makeUrls($itemTitle);
                if(substr($item->get_permalink(),0,28)=='http://www.youtube.com/watch') {
                    $this->output .= "<object width='560' height='340'><param name='movie' value='" . $this->youtubeEmbed($item->get_permalink()) . "'></param><param name='allowFullScreen' value='true'></param><param name='allowscriptaccess' value='always'></param><embed src='" . $this->youtubeEmbed($item->get_permalink()) . "' type='application/x-shockwave-flash' allowscriptaccess='always' allowfullscreen='true' width='560' height='340'></embed></object>";
                }
                $this->output .= "<br /><span><a href='" . $item->get_permalink() . "'>" . $this->timeAgo(strtotime($item->get_date())) . "</a></span>";
                $this->output .=  "</li>\n";
                $this->i++;
            }
            $this->output .= "</ul>\n";
        }
        return $this->output;
    }
    
    function youtubeEmbed($text) {
        return preg_replace('/http:\/\/(www.)?(youtu.be\/|youtube.com\/watch\?v=)([a-zA-Z0-9?%.;:\\/=+_-]+)([&]*([a-zA-Z0-9?&%.;:\\/=+_-]*))/i', 'http://www.youtube.com/v/$3?fs=1&amp;hl=en_US', $text);
    }

    function timeAgo($timestamp,$output = 'less than a minute ago') {
        $timestamp = time() - $timestamp;
        $units = array(604800=>'week',86400=>'day',3600=>'hour',60=>'minute');
        foreach($units as $seconds => $unit) {
            if($seconds<=$timestamp) {
                $value = floor($timestamp/$seconds);
                $output = 'about '.$value.' '.$unit.($value == 1 ? NULL : 's').' ago';
                break;
            }
        }
        return $output;
    }
    
    function shortenUrl($url,$length) {
        $output = substr($url, 0, $length);
        if(isset($url[$length]))
            $output .= '...';
        return $output;
    }
    
    function makeUrls($text) {
        $text = preg_replace("/((http(s?):\/\/)|(www\.))([\w\.]+)([a-zA-Z0-9?&%.;:\/=+_-]+)/ie", "'<a href=\"http$3://$4$5$6\" target=\"_blank\">' . \$this->shortenUrl(\"$2$4$5$6\",25) . '</a>'", $text);
        $text = preg_replace("/(?<=\A|[^A-Za-z0-9_])@([A-Za-z0-9_]+)(?=\Z|[^A-Za-z0-9_])/", "<a href='http://twitter.com/$1' target='_blank'>$0</a>", $text);
        $text = preg_replace("/(?<=\A|[^A-Za-z0-9_])#([A-Za-z0-9_]+)(?=\Z|[^A-Za-z0-9_])/", "<a href='http://twitter.com/search?q=%23$1' target='_blank'>$0</a>", $text);
        return $text;
    }
    
}

?>
